<?php

class Verifone_Hosted_Refund extends Verifone_Api_Entity {

	/**
	 * @var \WC_Order
	 */
	private $order;

	/**
	 * @var array
	 */
	protected $data;
	private $amount;
	private $reason;

	public function __construct(
		$amount,
		$reason,
		WC_Order $order
	) {
		$this->order    = $order;
		$this->amount   = $amount;
		$this->reason   = $reason;

		$this->buildData();
	}

	/**
	 * @throws \Exception
	 */
	private function buildData() {
		$date = new DateTime('now');
		$this->data = [
			// the api requires that all params are string...for this endpoint
			// in the initial call the amount has to be an int
			// but it seems to work with a string too
			// talk about consistency...
			'amount' => "{$this->amount}",
			'reason' => $this->reason,
			'id' => "{$this->order->get_meta(VERIFONE_ORDER_TRANSACTION_ID)}",
			'referenceId' => "{$this->order->get_id()}",
			'createdDateTime' => "{$date->format( 'Y-m-d\TH:i:s\Z' )}"
		];
	}

	/**
	 * @return array
	 */
	public function toArray()
	{
		return $this->data;
	}

	/**
	 * @return false|string
	 */
	public function toJson() {
		return json_encode($this->data);
	}

}
