<?php

function getVerifoneHostedCartFormFields() {

	return [
		'general_settings'         => [
			'title'       => __( 'General settings', 'woocommerce' ),
			'type'        => 'title',
			'description' => '<hr>',
		],
		'enabled'                  => [
			'desc_tip' => true,
			'title'    => __( 'Enable/Disable', 'woocommerce' ),
			'type'     => 'checkbox',
			'label'    => __( 'Enable Verifone Hosted Cart', 'woocommerce' ),
			'default'  => 'yes',
		],
		'title'                    => [
			'title'       => __( 'Title', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This controls the title of the payment method which the user sees during checkout.', 'woocommerce' ),
			'default'     => __( 'Card Payment', 'woocommerce' ),
			'desc_tip'    => true,
		],
		'description'              => [
			'title'       => __( 'Description', 'woocommerce' ),
			'type'        => 'text',
			'desc_tip'    => true,
			'description' => __( 'This controls the description which the user sees during checkout.', 'woocommerce' ),
			'default'     => __( 'Payments powered by <a href="https://www.verifone.com/" target="_blank">Verifone </a>', 'woocommerce' ),
		],
		'test'                     => [
			'desc_tip'    => true,
			'title'       => __( 'Test mode', 'woocommerce' ),
			'type'        => 'select',
			'label'       => __( 'Test mode', 'woocommerce' ),
			'options'     => [
				'Test'       => 'Test',
				'Production' => 'Production',
			],
			'description' => __( 'Enables test or production mode.', 'woocommerce' ),
		],
		'region'                   => [
			'desc_tip'    => true,
			'title'       => __( 'Region', 'woocommerce' ),
			'type'        => 'select',
			'label'       => __( 'Region', 'woocommerce' ),
			'options'     => [
				// temporarily disabled
				//'EMEA' => 'EMEA ',
				//'NA'   => 'NA',
				'NZAU' => 'NZAU',
			],
			'description' => __( 'Select which region you are based in. Contact your Verifone representative if you are not sure.', 'woocommerce' ),
		],
		'production_settings'       => [
			'title'       => __( 'Production credentials', 'woocommerce' ),
			'type'        => 'title',
			'description' => '<hr>',
		],
		// Live Credentials
		'api_username'             => [
			'title'       => __( 'Username', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'Please enter the username you use to login to the Verifone portal.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'api_password'             => [
			'title'       => __( 'Password', 'woocommerce' ),
			'type'        => 'password',
			'description' => __( 'Please enter the password you use to login to the Verifone portal.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'api_client_id'            => [
			'title'       => __( 'Client ID', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'entity_id'                => [
			'title'       => __( 'Entity ID', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'payment_contract_id'      => [
			'title'       => __( 'Payment Contract Id', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided to you by a Verifone employee. It can also be found in the Verifone portal by navigating to the Payment Provider Contract menu underneath Admin. From the URL grab the ID formatted like xxx-xxx-xxx-xxxx',
				'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'_3ds_contract_id'         => [
			'title'       => __( '3DS Contract Id', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		// End Live Credentials
		'test_settings'             => [
			'title'       => __( 'Test credentials', 'woocommerce' ),
			'type'        => 'title',
			'description' => '<hr>',
		],
		// Test Credentials
		'test_api_username'        => [
			'title'       => __( 'Test Username', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'Please enter the username you use to login to the Verifone portal.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'test_api_password'        => [
			'title'       => __( 'Test Password', 'woocommerce' ),
			'type'        => 'password',
			'description' => __( 'Please enter the password you use to login to the Verifone portal.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'test_api_client_id'       => [
			'title'       => __( 'Test Client ID', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'test_entity_id'           => [
			'title'       => __( 'Test Entity ID', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'test_payment_contract_id' => [
			'title'       => __( 'Test Payment Contract Id', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided to you by a Verifone employee. It can also be found in the Verifone portal by navigating to the Payment Provider Contract menu underneath Admin. From the URL grab the ID formatted like xxx-xxx-xxx-xxxx',
				'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		'test_3ds_contract_id'     => [
			'title'       => __( 'Test 3DS Contract Id', 'woocommerce' ),
			'type'        => 'text',
			'description' => __( 'This is provided by a Verifone employee.', 'woocommerce' ),
			'default'     => '',
			'desc_tip'    => true,
			'placeholder' => '',
		],
		// End Test Credentials
		'payment_settings'         => [
			'title'       => __( 'Payment options', 'woocommerce' ),
			'type'        => 'title',
			'description' => '<hr>',
		],
		'_3ds_enable'              => [
			'desc_tip'    => true,
			'title'       => __( '3DS', 'woocommerce' ),
			'type'        => 'select',
			'label'       => __( '3DS', 'woocommerce' ),
			'options'     => [
				'Yes' => 'Yes',
				'No'  => 'No',
			],
			'description' => __( 'Enables or disables 3D-Secure for all payments.', 'woocommerce' ),
		],
		// removed
//		'cvv_on_payment'           => [
//			'desc_tip'    => true,
//			'title'       => __( 'CVV on payment', 'woocommerce' ),
//			'type'        => 'select',
//			'label'       => __( 'CVV on payment', 'woocommerce' ),
//			'options'     => [
//				'Yes' => 'Yes',
//				'No'  => 'No',
//			],
//			'description' => __( 'Requires the CVV  when shoppers pay with a card.', 'woocommerce' ),
//		],
		'advanced_settings'      => [
			'title'       => __( 'Advanced options', 'woocommerce' ),
			'type'        => 'title',
			'description' => '<hr>',
		],
		'curl_verify_ssl'        => [
			'title'       => __( 'Enable/Disable cURL verify host and peer', 'woocommerce' ),
			'description' => __( 'This option determines whether curl verifies the authenticity of the peer\'s and host certificates.',
				'woocommerce' ),
			'desc_tip'    => true,
			'type'        => 'checkbox',
			'label'       => __( 'Enable/Disable cURL verify host and peer', 'woocommerce' ),
			'default'     => 'yes',
		],
		'overlay_on_place_order' => [
			'title'       => __( 'Enable/Disable overlay when placing order', 'woocommerce' ),
			'description' => __( 'This option will enable an overlay when placing an oder. This is nothing more than a visual indication for the user that the request is starting',
				'woocommerce' ),
			'desc_tip'    => true,
			'type'        => 'checkbox',
			'label'       => __( 'Enable/Disable overlay when placing order', 'woocommerce' ),
			'default'     => 'yes',
		],
	];
}
