<?php

require_once __DIR__ . '/../bootstrap.php';

class VerifoneHostedHelperTest extends \WP_Mock\Tools\TestCase {

	public function test_getDeviceType() {
		$mobileDetectMock = $this->getMockBuilder( Mobile_Detect::class )
			->disableOriginalConstructor()
			->setMethods( [
				'isMobile',
				'isTablet',
			] )
			->getMock()
		;

		$mobileDetectMock->expects( $this->any() )
			->method( 'isMobile' )
			->willReturn( false )
		;
		$mobileDetectMock->expects( $this->any() )
			->method( 'isTablet' )
			->willReturn( false )
		;

		$testClass = new Verifone_Hosted_Helper();
		$testClass->setMobileDetectClass($mobileDetectMock);

		$this->assertEquals('S', $testClass->getDeviceType());

		// mobile
		$mobileDetectMock = $this->getMockBuilder( Mobile_Detect::class )
			->disableOriginalConstructor()
			->setMethods( [
				'isMobile',
				'isTablet',
			] )
			->getMock()
		;

		$mobileDetectMock->expects( $this->any() )
			->method( 'isMobile' )
			->willReturn( true )
		;
		$mobileDetectMock->expects( $this->any() )
			->method( 'isTablet' )
			->willReturn( false )
		;

		$testClass = new Verifone_Hosted_Helper();
		$testClass->setMobileDetectClass($mobileDetectMock);

		$this->assertEquals('P', $testClass->getDeviceType());

		//tablet
		$mobileDetectMock = $this->getMockBuilder( Mobile_Detect::class )
			->disableOriginalConstructor()
			->setMethods( [
				'isMobile',
				'isTablet',
			] )
			->getMock()
		;

		$mobileDetectMock->expects( $this->any() )
			->method( 'isMobile' )
			->willReturn( false )
		;
		$mobileDetectMock->expects( $this->any() )
			->method( 'isTablet' )
			->willReturn( true )
		;

		$testClass = new Verifone_Hosted_Helper();
		$testClass->setMobileDetectClass($mobileDetectMock);

		$this->assertEquals('T', $testClass->getDeviceType());

	}

}
