<?php

require_once __DIR__ . '/../bootstrap.php';

class VerifoneHostedRefundTest extends \WP_Mock\Tools\TestCase {

	public function test_Class() {
		$orderMock = $this->getMockBuilder( WC_Order::class )
			->disableOriginalConstructor()
			->setMethods( [
				'get_date_created',
				'get_id',
				'get_meta',
			] )
			->getMock()
		;

		$dataTime = new DateTime('now');
		$orderMock->expects( $this->exactly(1) )
			->method( 'get_date_created' )
			->willReturn( $dataTime )
		;
		$orderMock->expects( $this->exactly(1) )
			->method( 'get_id' )
			->willReturn( 1 )
		;
		$orderMock->expects( $this->exactly(1) )
			->method( 'get_meta' )
			->willReturn( 'test_meta' )
		;

		$data = [
			'amount' => "1",
			'reason' => 'test_reason',
			'id' => "test_meta",
			'referenceId' => "1",
			'createdDateTime' => "{$dataTime->format( 'Y-m-d\TH:i:s\Z' )}"
		];

		$testClass = new Verifone_Hosted_Refund(1, 'test_reason', $orderMock);
		$this->assertEquals($data, $testClass->toArray());
		$this->assertEquals(strlen(json_encode($data)),strlen( $testClass->toJson()));

		// test exception
		$this->expectException(Exception::class);

		$orderMock = $this->getMockBuilder( WC_Order::class )
			->disableOriginalConstructor()
			->setMethods( [
				'get_date_created',
				'get_id',
				'get_meta',
			] )
			->getMock()
		;

		$orderMock->expects( $this->exactly(1) )
			->method( 'get_date_created' )
			->willReturn( 'invalid_instance_of_date_time' )
		;

		new Verifone_Hosted_Refund(1, 'test_reason', $orderMock);
	}

}
