<?php

require_once __DIR__ . '/../bootstrap.php';

class VerifoneSettingsTest extends \WP_Mock\Tools\TestCase {
	// constants aren't tested
	// see to this https://stackoverflow.com/a/39287019/4729332
	// written by the man himself

	public function test_SettersGetters()
	{
		$settings = new Verifone_Hosted_Cart_Settings();

		// non conditional
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setOverlayOnPlaceOrder(true));
		$this->assertSame(true, $settings->getOverlayOnPlaceOrder());
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setCurlVerifySsl(true));
		$this->assertSame(true, $settings->getCurlVerifySsl());
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setRegion('NA'));
		$this->assertSame('NA', $settings->getRegion());
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->set3dsEnable(true));
		$this->assertSame(true, $settings->is3dsEnabled());
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setCvvOnPayment(true));
		$this->assertSame(true, $settings->getCvvOnPayment());

		// conditional
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTest(true));
		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestPaymentContractId('test_true'));
		$this->assertSame('test_true', $settings->getPaymentContractId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTest3dsContractId('test_true'));
		$this->assertSame('test_true', $settings->get3dsContractId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestEntityId('test_true'));
		$this->assertSame('test_true', $settings->getEntityId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->set3dsContractId('test_true'));
		$this->assertSame('test_true', $settings->get3dsContractId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestEntityId('test_true'));
		$this->assertSame('test_true', $settings->getEntityId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestApiUsername('test_true'));
		$this->assertSame('test_true', $settings->getApiUsername());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestApiPassword('test_true'));
		$this->assertSame('test_true', $settings->getApiPassword());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setTestApiClientId('test_true'));
		$this->assertSame('test_true', $settings->getApiClientId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setPaymentContractId('test_true'));
		$this->assertSame('test_true', $settings->getPaymentContractId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setApiUsername('test_true'));
		$this->assertSame('test_true', $settings->getApiUsername());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setApiPassword('test_true'));
		$this->assertSame('test_true', $settings->getApiPassword());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setApiClientId('test_true'));
		$this->assertSame('test_true', $settings->getApiClientId());

		$this->assertInstanceOf(Verifone_Hosted_Cart_Settings::class, $settings->setEntityId('test_true'));
		$this->assertSame('test_true', $settings->getEntityId());

		$settings = new Verifone_Hosted_Cart_Settings();
		$this->assertNull($settings->getEntityId());
		$this->assertNull($settings->getApiPassword());
		$this->assertNull($settings->getApiClientId());
		$this->assertNull($settings->getRegion());
		$this->assertNull($settings->getApiUsername());
		$this->assertNull($settings->getCurlVerifySsl());
		$this->assertNull($settings->get3dsContractId());
		$this->assertNull($settings->getPaymentContractId());
		$this->assertNull($settings->getOverlayOnPlaceOrder());
		$this->assertNull($settings->getCvvOnPayment());
	}

}
